From decwrl!elroy.jpl.nasa.gov!usc!cs.utexas.edu!uunet!allbery Sun Feb 18 00:50:57 PST 1990
Article 1343 of comp.sources.misc:
Path: decwrl!elroy.jpl.nasa.gov!usc!cs.utexas.edu!uunet!allbery
From: bby@alliant.com@y.UUCP (Bob Mastors)
Newsgroups: comp.sources.misc
Subject: v10i072: genman.awk - generate man page from C++ include file
Message-ID: <79120@uunet.UU.NET>
Date: 17 Feb 90 02:39:06 GMT
Sender: allbery@uunet.UU.NET
Lines: 664
Approved: allbery@uunet.UU.NET (Brandon S. Allbery - comp.sources.misc)

Posting-number: Volume 10, Issue 72
Submitted-by: bby@alliant.com@y.UUCP (Bob Mastors)
Archive-name: genman.awk

The purpose of the genman.awk program is to generate documentation about
a C++ class from the include file and source files.

You will need the newer version of awk that supports user defined functions.
I would appreciate receiving any bug fixes or enhancements.

---
Bob Mastors
Epoch Systems, Marlboro MA (508) 481-3717 (voice)
                           (508) 485-3241 (fax)
{linus!alliant, harvard!cfisun}!palladium!bby

-----------------------------CUT HERE------------------------------
#! /bin/sh
# This is a shell archive, meaning:
# 1. Remove everything above the #! /bin/sh line.
# 2. Save the result in a file
# 3. Execute the file with /bin/sh (not csh)
echo extracting - README
sed 's/^X//' > README << 'FRIDAY_NIGHT'
XThe purpose of the genman.awk program is to generate documentation about
Xa C++ class from the include file and source files.
X
XAn example of the output is in the file strloc.man.  The input is in the
Xfiles strloc.h and strloc.cxx.  The strloc class is only provided as
Xan example of how to use genman.awk.
FRIDAY_NIGHT
echo extracting - genman.awk
sed 's/^X//' > genman.awk << 'FRIDAY_NIGHT'
X#
X# Awk program that takes as input a C++ header file and outputs
X# a UNIX style man page.
X#
X# The contents of this file are public domain.
X# Author: Bob Mastors
X#         Epoch Systems, Inc.
X#         2/90
X
XBEGIN	{
X	# specify how much to indent the various parts
X	INDENT_1 = ""
X	INDENT_2 = "  "
X	INDENT_3 = "     "
X	library= "UNKNOWN"
X	arfilecount= 0
X	}
X
X/^#define/ {
X	tmp= substr( $0, 8 )
X	tmp= strip_white( tmp )
X	gsub( "\\\\$", "", tmp );
X	define = define INDENT_3 tmp "\n"
X	}
X
X/^#include/ {
X	tmp= substr( $0, 9 )
X	tmp= strip_white( tmp )
X	include = include INDENT_3 tmp "\n"
X	}
X
X/^typedef/ {
X	tmp= substr( $0, 8 )
X	tmp= strip_white( tmp )
X	typedef = typedef INDENT_3 tmp "\n"
X	}
X
X/^enum/ {
X	tmp= substr( $0, 5 )
X	gsub( "{", "", tmp );
X	tmp= strip_white( tmp )
X	enum= enum INDENT_2 tmp "\n"
X	while( (getline tmp) > 0 )
X		{
X		gsub( "{", "", tmp );
X		gsub( ",", " ", tmp );
X		gsub( "//", "", tmp );
X		tmp= strip_white( tmp )
X		if( tmp ~ "} *;" )
X			break;
X		enum= enum INDENT_3 tmp "\n"
X		}
X	}
X
X/^struct/ {
X	tmp= substr( $0, 7 )
X	tmp= strip_white( tmp )
X	struct= struct INDENT_2 tmp "\n"
X	while( (getline tmp) > 0 )
X		{
X		tmp= strip_white( tmp )
X		gsub( "//", "  ", tmp );
X		struct= struct INDENT_3 tmp "\n"
X		if( tmp ~ "} *;" )
X			break;
X		}
X	}
X
X/^class/ {
X	tmp= substr( $0, 6 )
X	tmp= strip_white( tmp )
X	gsub( "{", "", tmp )
X	class= class doc
X	doc= ""
X	process_class( tmp )
X	}
X
X/^\/\// {
X	tmp= substr( $0, 4 )
X	striptmp= strip_white( tmp )
X	if( gsub( "^\.FILE", "", striptmp ) == 1 )
X		{
X		striptmp= strip_white( striptmp )
X		file= file INDENT_3 striptmp "\n"
X		arfile[ striptmp ] = striptmp
X		arfilecount++
X		}
X	else
X	if( gsub( "^\.LIBRARY", "", striptmp ) == 1 )
X		{
X		striptmp= strip_white( striptmp )
X		library= toupper( striptmp )
X		}
X	else
X	if( gsub( "^\.SECTION", "", striptmp ) == 1 )
X		{
X		striptmp= strip_white( striptmp )
X		striptmp= toupper( striptmp )
X		doc= doc INDENT_1 striptmp "\n"
X		doc_flag= "true"
X		}
X	else if( doc_flag == "true" )
X		{
X		doc= doc INDENT_2 tmp "\n"
X		}
X	}
X
XNF == 0 {
X	if( (doc_flag == "true") && (length(doc) > 0) )
X		doc= doc "\n"
X	doc_flag= ""
X	}
X
XEND	{
X	print
X	tmp= toupper(FILENAME) "(c++) "
X	printf( "%-35s %-10s %31s\n", tmp, library, tmp );
X	"date '+%h %d, 19%y'" | getline tmp
X	print
X	printf( "%77s\n", tmp )
X	print_section( "", class )
X	print_section( "", doc )
X	print_section( "DEFINED MACROS", define )
X	print_section( "INCLUDED FILES", include )
X	print_section( "TYPE DEFINITIONS", typedef )
X	print_section( "ENUMERATIONS", enum )
X	print_section( "STRUCTURES", struct )
X	print_section( "SOURCE FILES", file )
X	print_summarys()
X	}
X
X# prints out the specified header and data if the data string
X# is not zero length
Xfunction print_section( header, data )
X	{
X	if( length(data) > 0 )
X		{
X		print INDENT_1 header
X		print data
X		}
X	}
X
X# Call to process a class.  Pass the name of the class.
Xfunction process_class( name,    inputstr,ii,bers )
X	{
X	# get lines of input until EOF
X	ii= "private"
X	while( (getline inputstr) > 0 )
X		{
X		# just get the token(s)
X		inputstr= strip_white( inputstr )
X
X		# ignore single {
X		if( inputstr == "{" )
X			continue
X
X		# all done if found end of class definition
X		if( inputstr ~ "} *;" )
X			break;
X
X		# public members follow
X		if( inputstr ~ "public *:" )
X			ii= "public"
X
X		# private members follow
X		else if( inputstr ~ "private *:" )
X			ii= "private"
X
X		# protected members follow
X		else if( inputstr  ~ "protected *:" )
X			ii= "protected"
X
X		else if( (length(inputstr) > 0) || (length(bers[ii]) > 0) )
X			{
X			gsub( "//", "  ", inputstr )
X			if( length(inputstr) > 0 )
X				bers[ii]= bers[ii] INDENT_3 inputstr "\n"
X			else
X				bers[ii]= bers[ii] "\n"
X			}
X		}
X
X	# construct the class string
X	class= class INDENT_1 "CLASS " name "\n\n"
X	if( length( bers[ "public" ] ) > 0 )
X		{
X		class= class INDENT_2 "Public members\n"
X		class= class strip_nl( bers["public"] ) "\n\n"
X		}
X	if( length( bers[ "protected" ] ) > 0 )
X		{
X		class= class INDENT_2 "Protected members\n"
X		class= class strip_nl( bers["protected"] ) "\n\n"
X		}
X	if( length( bers[ "private" ] ) > 0 )
X		{
X		class= class INDENT_2 "Private members\n"
X		class= class strip_nl( bers["private"] ) "\n\n"
X		}
X	if( length( bers[ "friend" ] ) > 0 )
X		{
X		class= class INDENT_2 "Friends\n"
X		class= class strip_nl( bers["friend"] ) "\n\n"
X		}
X	}
X
X# strips leading and trailing whitespace from the specified string and
X# returns the string
Xfunction strip_white( data )
X	{
X	gsub( "^[\t ]+", "", data )
X	gsub( "[\t ]+$", "", data )
X	return data
X	}
X
X# strips leading and trailing newlines from the specified string and
X# returns the string
Xfunction strip_nl( data )
X	{
X	gsub( "\n", "@", data )
X	gsub( "@+$", "", data )
X	gsub( "@", "\n", data )
X	return data
X	}
X
X# Call to get the function summarys from the source files and print them
Xfunction print_summarys(   data,title )
X    {
X    # just return if no source files listed
X    if( arfilecount == 0 )
X        return;
X
X    # print the header
X    print INDENT_1 "SUMMARY"
X
X    # walk the list of source files
X    for( xx in arfile )
X	{
X        # loop reading each line of the source file
X	while( (getline inputstr <arfile[xx]) > 0 )
X	    {
X            # see if the start of the function summary
X	    if( inputstr ~ "// Description:$" )
X		{
X		data= ""
X		title= ""
X                # loop reading the summary
X		while( (getline inputstr <arfile[xx]) > 0 )
X		    {
X                    # see if all done
X		    if( inputstr ~ "{.*" )
X			{
X			title= strip_nl( title )
X			print title
X			print data
X			break;
X			}
X
X		    # strip the comment and leading whitespace
X		    if( gsub( "//[\t ]*", "", inputstr ) != 0 )
X			{
X			# only keep lines not ending in :
X			if( inputstr !~ ".*:$" )
X			    {
X                            # save the line of data
X			    data= data INDENT_3 inputstr "\n"
X			    }
X			}
X		    else
X			{
X			# only keep lines that are not blank
X			if( length( inputstr ) )
X			    {
X                            # save the line of the function name
X			    title= title INDENT_2 inputstr "\n"
X			    }
X			}
X		    }
X		}
X	    }
X	}
X    }
FRIDAY_NIGHT
echo extracting - strloc.cxx
sed 's/^X//' > strloc.cxx << 'FRIDAY_NIGHT'
X//------------------------------------------------------------
X//
X//			strloc.cxx
X//
X// Purpose:
X//	Implements the strloc class
X
X#include <string.h>
X#include <util/list.h>
X#include <util/strloc.h>
X
X//------------------------------------------------------------
X//
X//            strloc
X//
X// Description:
X//    Normal constructor.
X// Arguments:
X//    Passed a pointer to a character string it copies it
X//    to new memory and sets the reference count to 1.
X
Xstrloc::strloc( const char *newstr )
X    {
X    // get a structure to hold the string pointer and ref count
X    st_com= new strloc_data;
X    st_com->std_refcnt= 1;
X
X    if( newstr == 0 )
X        newstr= "";
X
X    // get the length of the string
X    int len= strlen( newstr ) +1;
X
X    // get some space for the string
X    st_com->std_ptr= new char[len];
X
X    // copy the data
X    strcpy( st_com->std_ptr, newstr );
X    }
X
X//------------------------------------------------------------
X//
X//            strloc
X//
X// Description:
X//    Constructor called when strloc a= b.
X// Arguments:
X//    "this" is "a" and "orig" is a pointer to "b".
X
Xstrloc::strloc( strloc &orig )
X    {
X    // have "a" point to the same string structure as "b"
X    st_com= orig.st_com;
X
X    // update the reference count
X    st_com->std_refcnt += 1;
X    }
X
X//------------------------------------------------------------
X//
X//            ~strloc
X//
X// Description:
X//    Destructor for the strloc class.
X//    The refernce count is decrimented and when it goes to
X//    zero the string is deleted.
X
Xstrloc::~strloc()
X    {
X    // decriment the reference count
X    st_com->std_refcnt -= 1;
X
X    // see if nothing else pointing to the string
X    if( st_com->std_refcnt == 0 )
X        {
X        delete st_com->std_ptr;    // delete the string
X        delete st_com;             // delete the string structure
X        }
X    }
X
X//------------------------------------------------------------
X//
X//            operator=
X//
X// Description:
X//    Implements copy function.
X//    Frees up old string and copies a pointer to the new one.
X// Arguments:
X
Xstrloc & strloc::operator=( strloc &rvalue )
X    {
X    // incriment the source string reference count
X    rvalue.st_com->std_refcnt += 1;
X
X    // decriment the orig reference count
X    st_com->std_refcnt -= 1;
X
X    // see if nothing else pointing to the string
X    if( st_com->std_refcnt == 0 )
X        {
X        delete st_com->std_ptr;    // delete the string
X        delete st_com;             // delete the string structure
X        }
X
X    // point this to the rvalue string structure
X    st_com= rvalue.st_com;
X
X    return *this;
X    }
X
X//------------------------------------------------------------
X//
X//            operator=
X//
X// Description:
X//    Implements set function: strloc a; a= "foo";
X//    Frees up old string and copies a pointer to the new one.
X
Xstrloc & strloc::operator=( const char *newstr )
X    {
X    // decriment the orig reference count
X    st_com->std_refcnt -= 1;
X
X    // see if nothing else pointing to the string
X    if( st_com->std_refcnt == 0 )
X        {
X        delete st_com->std_ptr;    // delete the string
X        delete st_com;             // delete the string structure
X        }
X
X    // get a structure to hold the string pointer and ref count
X    st_com= new strloc_data;
X    st_com->std_refcnt= 1;
X
X    if( newstr == 0 )
X        newstr= "";
X
X    // get the length of the string
X    int len= strlen( newstr ) +1;
X
X    // get some space for the string
X    st_com->std_ptr= new char[len];
X
X    // copy the data
X    strcpy( st_com->std_ptr, newstr );
X
X    return *this;
X    }
X
X//-----------------------------------------------------------
X//
X//                    operator+=
X//
X// Description:
X//  Appends the specified string onto the end of the current string.
X
Xvoid strloc::operator+=( const char *string )
X    {
X    // just return if no string specified
X    if( (string == NULL) || (*string == '\0') )
X        return;
X
X    // determine the length of the new string
X    int len= strlen( st_com->std_ptr ) + strlen( string ) +1;
X
X    // get some space for the string
X    char *ptr= new char[len];
X
X    // copy the data
X    strcpy( ptr, st_com->std_ptr );
X    strcat( ptr, string );
X
X    // delete the original data
X    delete st_com->std_ptr;
X
X    // save the pointer to the new data
X    st_com->std_ptr= ptr;
X    }
FRIDAY_NIGHT
echo extracting - strloc.h
sed 's/^X//' > strloc.h << 'FRIDAY_NIGHT'
X//------------------------------------------------------------
X//
X//			strloc.h
X//
X// Purpose:
X//	Defines the strloc class.
X
X// .SECTION Description
X// The strloc class is a class for managing strings.
X// It uses reference counts on copy operations.
X
X// .LIBRARY Base
X// .FILE strloc.cxx
X// .FILE strloc.h
X
X#ifndef UTIL_STRLOC_H
X#define UTIL_STRLOC_H
X
X#ifndef STRINGS_HXX
X#include <strings.hxx>
X#endif
X
Xstruct strloc_data
X    {
X    char *std_ptr;      // pointer to string
X    int   std_refcnt;   // reference count
X    };
X
Xclass strloc
X    {
Xprivate:
X    strloc_data *st_com;
X    // Pointer to character string struct.
X
Xpublic:
X    strloc( const char *str= 0 );
X    strloc( strloc & );
X    ~strloc();
X    strloc & operator=( strloc & );
X    strloc & operator=( const char * );
X    void operator+=( const char * );
X    const char *ptr();
X    int len();
X    friend int operator==( const strloc &x, const char *s );
X    friend int operator==( const char *s, const strloc &x );
X    friend int operator==( const strloc &x, const strloc &y );
X    friend int operator!=( const strloc &x, const char *s );
X    friend int operator!=( const char *s, const strloc &x );
X    friend int operator!=( const strloc &x, const strloc &y );
X    };
X
X// Description:
X//  Returns the pointer to the string.
Xinline const char *strloc::ptr()
X    { return st_com->std_ptr; }
X
X// Description:
X//  Returns the length of the string.
Xinline int strloc::len()
X    { return strlen( st_com->std_ptr ); }
X
Xinline int operator==( const strloc &x, const char *s )
X    { return strcmp( x.st_com->std_ptr, s ) == 0; }
X
Xinline int operator==( const char *s, const strloc &x )
X    { return strcmp( x.st_com->std_ptr, s ) == 0; }
X
Xinline int operator==( const strloc &x, const strloc &y )
X    { return strcmp( x.st_com->std_ptr, y.st_com->std_ptr ) == 0; }
X
Xinline int operator!=( const strloc &x, const char *s )
X    { return strcmp( x.st_com->std_ptr, s ) != 0; }
X
Xinline int operator!=( const char *s, const strloc &x )
X    { return strcmp( x.st_com->std_ptr, s ) != 0; }
X
Xinline int operator!=( const strloc &x, const strloc &y )
X    { return strcmp( x.st_com->std_ptr, y.st_com->std_ptr ) != 0; }
X
X#endif /* UTIL_STRLOC_H */
FRIDAY_NIGHT
echo extracting - strloc.man
sed 's/^X//' > strloc.man << 'FRIDAY_NIGHT'
X
XSTRLOC.H(c++)                       BASE                        STRLOC.H(c++) 
X
X                                                                 Feb 14, 1990
X
XDESCRIPTION
X  The strloc class is a class for managing strings.
X  It uses reference counts on copy operations.
X
XCLASS strloc
X
X  Public members
X     strloc( const char *str= 0 );
X     strloc( strloc & );
X     ~strloc();
X     strloc & operator=( strloc & );
X     strloc & operator=( const char * );
X     void operator+=( const char * );
X     const char *ptr();
X     int len();
X     friend int operator==( const strloc &x, const char *s );
X     friend int operator==( const char *s, const strloc &x );
X     friend int operator==( const strloc &x, const strloc &y );
X     friend int operator!=( const strloc &x, const char *s );
X     friend int operator!=( const char *s, const strloc &x );
X     friend int operator!=( const strloc &x, const strloc &y );
X
X  Private members
X     strloc_data *st_com;
X        Pointer to character string struct.
X
X
XDEFINED MACROS
X     UTIL_STRLOC_H
X
XINCLUDED FILES
X     <strings.hxx>
X
XSTRUCTURES
X  strloc_data
X     {
X     char *std_ptr;         pointer to string
X     int   std_refcnt;      reference count
X     };
X
XSOURCE FILES
X     strloc.cxx
X     strloc.h
X
XSUMMARY
X  strloc::strloc( const char *newstr )
X     Normal constructor.
X     Passed a pointer to a character string it copies it
X     to new memory and sets the reference count to 1.
X
X  strloc::strloc( strloc &orig )
X     Constructor called when strloc a= b.
X     "this" is "a" and "orig" is a pointer to "b".
X
X  strloc::~strloc()
X     Destructor for the strloc class.
X     The refernce count is decrimented and when it goes to
X     zero the string is deleted.
X
X  strloc & strloc::operator=( strloc &rvalue )
X     Implements copy function.
X     Frees up old string and copies a pointer to the new one.
X
X  strloc & strloc::operator=( const char *newstr )
X     Implements set function: strloc a; a= "foo";
X     Frees up old string and copies a pointer to the new one.
X
X  void strloc::operator+=( const char *string )
X     Appends the specified string onto the end of the current string.
X
X  inline const char *strloc::ptr()
X     Returns the pointer to the string.
X
X  inline int strloc::len()
X     Returns the length of the string.
X
FRIDAY_NIGHT


